/**
 * @name ranges-regex
 * @fileoverview Integrate regex operations into Ranges workflow
 * @version 6.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-regex/}
 */

"use strict";var rangesRegex=(()=>{var $=Object.create;var y=Object.defineProperty;var F=Object.getOwnPropertyDescriptor;var A=Object.getOwnPropertyNames,d=Object.getOwnPropertySymbols,D=Object.getPrototypeOf,m=Object.prototype.hasOwnProperty,S=Object.prototype.propertyIsEnumerable;var h=(e,t,o)=>t in e?y(e,t,{enumerable:!0,configurable:!0,writable:!0,value:o}):e[t]=o,p=(e,t)=>{for(var o in t||(t={}))m.call(t,o)&&h(e,o,t[o]);if(d)for(var o of d(t))S.call(t,o)&&h(e,o,t[o]);return e};var H=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),N=(e,t)=>{for(var o in t)y(e,o,{get:t[o],enumerable:!0})},T=(e,t,o,s)=>{if(t&&typeof t=="object"||typeof t=="function")for(let a of A(t))!m.call(e,a)&&a!==o&&y(e,a,{get:()=>t[a],enumerable:!(s=F(t,a))||s.enumerable});return e};var W=(e,t,o)=>(o=e!=null?$(D(e)):{},T(t||!e||!e.__esModule?y(o,"default",{value:e,enumerable:!0}):o,e)),M=e=>T(y({},"__esModule",{value:!0}),e);var I=H((c,u)=>{var k="[object RegExp]",q=typeof global=="object"&&global&&global.Object===Object&&global,E=typeof c=="object"&&c&&!c.nodeType&&c,w=E&&typeof u=="object"&&u&&!u.nodeType&&u,C=w&&w.exports===E,v=C&&q.process,R=function(){try{return v&&v.binding("util")}catch(e){}}(),j=R&&R.isRegExp;function P(e){return function(t){return e(t)}}var U=Object.prototype,G=U.toString;function V(e){return z(e)&&G.call(e)==k}function z(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}var B=j?P(j):V;u.exports=B});var X={};N(X,{rRegex:()=>Q,version:()=>L});var J={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function f(e,t){if(!Array.isArray(e)||!e.length)return e;let o=p(p({},J),t),s,a;if(o.strictlyTwoElementsInRangeArrays&&!e.every((i,l)=>!Array.isArray(i)||i.length!==2?(s=l,a=i.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) has not two but ${a} elements!`);if(!e.every((i,l)=>!Array.isArray(i)||!Number.isInteger(i[0])||i[0]<0||!Number.isInteger(i[1])||i[1]<0?(s=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) does not consist of only natural numbers!`);let n=e.length**2,g=0;return Array.from(e).sort((i,l)=>(o.progressFn&&(g+=1,o.progressFn(Math.floor(g*100/n))),i[0]===l[0]?i[1]<l[1]?-1:i[1]>l[1]?1:0:i[0]<l[0]?-1:1))}var x={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function b(e,t){function o(r){return!!r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let s;if(t)if(o(t)){if(s=p(p({},x),t),s.progressFn&&o(s.progressFn)&&!Object.keys(s.progressFn).length)s.progressFn=null;else if(s.progressFn&&typeof s.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn,null,4)}`);if(![1,2,"1","2"].includes(s.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);if(typeof s.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(t,null,4)} (type ${typeof t})`);else s=p({},x);let a=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),n,g,i;s.progressFn?n=f(a,{progressFn:r=>{i=Math.floor(r/5),i!==g&&(g=i,s.progressFn(i))}}):n=f(a);let l=n.length-1;for(let r=l;r>0;r--)s.progressFn&&(i=Math.floor((1-r/l)*78)+21,i!==g&&i>g&&(g=i,s.progressFn(i))),(n[r][0]<=n[r-1][0]||!s.joinRangesThatTouchEdges&&n[r][0]<n[r-1][1]||s.joinRangesThatTouchEdges&&n[r][0]<=n[r-1][1])&&(n[r-1][0]=Math.min(n[r][0],n[r-1][0]),n[r-1][1]=Math.max(n[r][1],n[r-1][1]),n[r][2]!==void 0&&(n[r-1][0]>=n[r][0]||n[r-1][1]<=n[r][1])&&n[r-1][2]!==null&&(n[r][2]===null&&n[r-1][2]!==null?n[r-1][2]=null:n[r-1][2]!=null?+s.mergeType==2&&n[r-1][0]===n[r][0]?n[r-1][2]=n[r][2]:n[r-1][2]+=n[r][2]:n[r-1][2]=n[r][2]),n.splice(r,1),r=n.length);return n.length?n:null}var _=W(I(),1);var O="6.0.5";var L=O;function Q(e,t,o){if(e===void 0)throw new TypeError("ranges-regex: [THROW_ID_01] The first input's argument must be a regex object! Currently it is missing!");if(!(0,_.default)(e))throw new TypeError(`ranges-regex: [THROW_ID_02] The first input's argument must be a regex object! Currently its type is: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(typeof t!="string")throw new TypeError(`ranges-regex: [THROW_ID_03] The second input's argument must be a string! Currently its type is: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);if(o&&typeof o!="string")throw new TypeError(`ranges-regex: [THROW_ID_04] The third input's argument must be a string or null! Currently its type is: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);if(!t.length)return null;let s,a=[];if(o===null||typeof o=="string"&&o.length)for(;(s=e.exec(t))!==null;)a.push([e.lastIndex-s[0].length,e.lastIndex,o]);else for(;(s=e.exec(t))!==null;)a.push([e.lastIndex-s[0].length,e.lastIndex]);return a.length?b(a):null}return M(X);})();
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
